.use image php:
    image: rootaccess/php:7.4-cli


.only tags:
    only:
        refs:
            - tags


.cache:
    cache:
        key: ${CI_COMMIT_REF_SLUG}
        untracked: true

.cache push:
    extends: .cache
    cache:
        policy: push

.cache pull:
    extends: .cache
    cache:
        policy: pull

.cache pull-push:
    extends: .cache
    cache:
        policy: pull-push

.cache build:
    cache:
        key: ${CI_COMMIT_REF_SLUG} build
        paths:
            - .composer/cache/
            - .Build/
            - /tmp/phpstan/
            - /tmp/cache/PHPStan/


.artifacts:
    artifacts:
        name: "$CI_JOB_NAME--$CI_COMMIT_SHORT_SHA--$CI_PIPELINE_ID--$CI_JOB_ID"
        expire_in: 4 hours

.artifacts build:
    extends:
        - .artifacts
    artifacts:
        expose_as: 'build artifacts'
        paths:
            - .Build/


variables:
    BUILD_COMPOSER_ADDITIONAL_ARGUMENTS:
        description: Additional arguments when running `composer install` (build stage)

    DEPLOY_TAILOR_SET_VERSION_ADDITIONAL_ARGUMENTS:
        description: Additional arguments when running `tailor set-version` (deploy stage)
    DEPLOY_TAILOR_TER_PUBLISH_ADDITIONAL_ARGUMENTS:
        description: Additional arguments when running `tailor ter:publish` (deploy stage)

default:
    interruptible: true

.stage build:
    stage: build

.stage test:
    stage: test

.stage deploy:
    stage: deploy
    interruptible: false

stages:
    - build
    - test
    - deploy


before_script:
    # Validate Date/Time
    - date

    # Set proper file permissions
    - umask 002
    - find . -type f -not -executable -exec chmod 0664 {} \;
    - find . -type d -exec chmod 2775 {} \;

    # initialize submodule - if there are any
    - git submodule update --init --recursive

build composer:install:
    extends:
        - .use image php
        - .stage build
        - .cache build
        - .artifacts build
    script:
        # - composer check-platform-reqs
        - echo -e "\e[0Ksection_start:`date +%s`:composer_install\r\e[0Kcomposer install"
        - composer install --optimize-autoloader --no-progress --prefer-dist ${BUILD_COMPOSER_ADDITIONAL_ARGUMENTS}
        - echo -e "\e[0Ksection_end:`date +%s`:composer_install\r\e[0K"


deploy tailor ter:publish:
    extends:
        - .use image php
        - .stage deploy
        - .only tags
    stage: deploy
    needs:
        - "build composer:install"
    cache: { }
    script:
        - VERSION=$(echo ${CI_COMMIT_TAG} | sed -E 's/v([0-9]+\.[0-9]+\.[0-9]+)/\1/')
        - echo "Uploading verson $VERSION…"
        - env
        - .Build/bin/tailor set-version ${VERSION} ${DEPLOY_TAILOR_SET_VERSION_ADDITIONAL_ARGUMENTS}
        - .Build/bin/tailor ter:publish ${VERSION} --comment="[RELEASE] Release version ${CI_COMMIT_TAG}" ${DEPLOY_TAILOR_TER_PUBLISH_ADDITIONAL_ARGUMENTS}
    variables:
        DEPLOY_DEPLOYER_STAGE: $CI_ENVIRONMENT_TIER
